//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Silver
#property  indicator_color2  Silver
#property  indicator_color3  Silver
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2



extern int BasePeriod = 1;
extern double PeriodStep = 6;
//---- indicator buffers
double     AverageDistanceBuffer[];
double     PriceBuffer[];
double     BottomDistanceBuffer[];
double     MA[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetLevelValue(0, 0.005);
   SetLevelValue(1, 0);
   SetLevelValue(2, -0.005);
   SetIndexDrawBegin(1,PriceBuffer);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,AverageDistanceBuffer);
   SetIndexBuffer(1,PriceBuffer);
   SetIndexBuffer(2,BottomDistanceBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MA Rainbow Consolidation");
   SetIndexLabel(0,"Average MA Distance");
   SetIndexLabel(1,"Space");
   SetIndexLabel(2,"Average Bottom Distance");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()





  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
  


//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++) {
   
   AverageDistanceBuffer[i] = (((
   
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 0), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 1), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
         
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 1), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 2), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
         
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 2), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 3), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
         
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 3), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 4), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
         
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 4), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 5), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
         
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 5), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 6), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
         
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 6), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 7), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
       
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 7), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 8), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 8), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 9), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 9), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 10), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 10), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 11), 0, MODE_LWMA, PRICE_CLOSE, i) ) +     
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 11), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 12), 0, MODE_LWMA, PRICE_CLOSE, i) ) +    
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 12), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 13), 0, MODE_LWMA, PRICE_CLOSE, i) ) +    
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 13), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 14), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 14), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 15), 0, MODE_LWMA, PRICE_CLOSE, i) ) +  
            
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 15), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 16), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
          
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 16), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 17), 0, MODE_LWMA, PRICE_CLOSE, i) ) +            
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 17), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 18), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 18), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 19), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 19), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 20), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 20), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 21), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 21), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 22), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 22), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 23), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 23), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 24), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 24), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 25), 0, MODE_LWMA, PRICE_CLOSE, i) ) +
      
      ( iMA(NULL, 0, BasePeriod + (PeriodStep * 25), 0, MODE_LWMA, PRICE_CLOSE, i) - 
          iMA(NULL, 0, BasePeriod + (PeriodStep * 26), 0, MODE_LWMA, PRICE_CLOSE, i) ) 
                                                                                       
          
          
          
          
   ) / 27) /*/ Point*/);
   
   

}
      
//---- signal line counted in the 2-nd buffer
//   for(i=0; i<limit; i++)

   

//---- third buffer
   //for(i=0; i<limit; i++)      
   

   
   
//---- done
   return(0);
 
  }
//+------------------------------------------------------------------+